#Import Libraries
import time, board, pwmio, digitalio, sdcardio, storage, mount_sd
from audiopwmio import PWMAudioOut as AudioOut
from adafruit_motor import servo
from adafruit_apds9960.apds9960 import APDS9960
from audiomp3 import MP3Decoder

#Set up the audio
path = "/sd/"

audio = AudioOut(board.GP22)

filename = "spice_must_flow.mp3"
mp3_file = open(path + filename, "rb")
decoder = MP3Decoder(mp3_file)

#Plays the audio and moves a servo depending on which gesture was made
def play_mp3(filename, servo):
    decoder.file = open(path + filename, "rb")
    audio.play(decoder)
    while audio.playing:
        if servo == servo_salt:
            for i in range(180):
                  servo.angle = i
                  time.sleep(.01)
            time.sleep(2)
        else:
            for j in range(180, -1 ,-1):
                  servo.angle = j
                  time.sleep(.01)
            time.sleep(2)

#Set up the door sensors
lid_sensor1 = digitalio.DigitalInOut(board.GP19)
lid_sensor1.switch_to_input(pull = digitalio.Pull.UP)

lid_sensor2 = digitalio.DigitalInOut(board.GP18)
lid_sensor2.switch_to_input(pull = digitalio.Pull.UP)

#Set up the gesture sensor
i2c = board.STEMMA_I2C()
multi_sensor = APDS9960(i2c)
multi_sensor.enable_proximity = True
multi_sensor.enable_gesture = True

#Set up the servos
pwm_salt = pwmio.PWMOut(board.GP14, frequency=50)
servo_salt = servo.Servo(pwm_salt, min_pulse = 700, max_pulse = 2300)

pwm_pepper = pwmio.PWMOut(board.GP15, frequency=50)
servo_pepper = servo.Servo(pwm_pepper, min_pulse = 500, max_pulse = 2500)

#Initialize the salt servo
status1 = "closed"
servo_salt.angle = 0
if lid_sensor1.value:
        status1 = "open"
        for i in range(180):
            servo_salt.angle = i
            time.sleep(.01)

#Initialize the pepper servo
status2 = "closed"
servo_pepper.angle = 180
if lid_sensor2.value:
    status2 = "open"
    for j in range(180, -1, -1):
        servo_pepper.angle = j
        time.sleep(.01)

while True:
    #Get the gesture
    gesture = multi_sensor.gesture()
    #Open the salt container if it's closed and the person swipes right
    if status1 == "closed":
        if gesture == 4:
            status1 = "open"
            play_mp3("spice_must_flow.mp3", servo_salt)
            time.sleep(1)
    #Open the pepper container if it's closed and the person swipes left
    if status2 == "closed":
        if gesture == 3:
            status2 = "open"
            play_mp3("spice_must_flow.mp3", servo_pepper)
            time.sleep(1)
    #Closes the salt container if it's open and the door sensor is closed
    if status1 == "open":
        if lid_sensor1.value:
            pass
        else:
            time.sleep(1)
            for j in range(180, -1, -1):
                servo_salt.angle = j
                time.sleep(.01)
            status1 = "closed"
    #Closes the pepper container if it's open and the door sensor is closed
    if status2 == "open":
        if lid_sensor2.value:
            pass
        else:
            time.sleep(1)
            for j in range(180):
                servo_pepper.angle = j
                time.sleep(.01)
            status2 = "closed"
    # time.sleep(.1)
#     print(status1 + " 1")
#     print(status2 + " 2")
